"""
This module implements a portal-managed File class.  It is based on
Zope's built-in File object, but modifies the behaviour slightly to
make it more Portal-friendly.
"""

from Globals import HTMLFile, HTML
from Products.PTKBase.PortalContent import PortalContent
from Discussions import Discussable
from Acquisition import Implicit
import Globals
import string

import Products.ExtFile.ExtFile

def addExtFile(self, file, title='', description='',
            content_type='', REQUEST=None):
    """
    Add a File
    """
    print "OK"
    self=self.this()  # Why?

    # Instantiate the object and set it's description.
    # The description is not set by the constructor because I didn't
    # want to extend File's constructor.  Perhaps I should.
    filename=REQUEST['file'].filename
    id=''
        # generate id from filename
    if (filename) and (type(file) is not type('')):
        id=filename[max(string.rfind(filename,'/'), string.rfind(filename,'\\'), string.rfind(filename,':'))+1:]
    if id:
        id=string.replace(id,' ','_')   # make sure, there are no spaces in the id
        tempExtFile=ExtFile(id, REQUEST, title, description, file, content_type)
        tempExtFile.description=tempExtFile.descr
    
        # Add the File instance to self
        self._setObject(id, tempExtFile)

    if REQUEST is not None:
        REQUEST.RESPONSE.redirect(self.absolute_url()+'/portal_contents')
    
class ExtFile(Products.ExtFile.ExtFile.ExtFile, PortalContent, Discussable):
    """
    A Portal-managed File
    """

    # The order of base classes is very significant in this case.
    # Image.File does not store it's id in it's 'id' attribute.
    # Rather, it has an 'id' method which returns the contents of the
    # instnace's __name__ attribute.  Inheriting in the other order
    # obscures this method, resulting in much pulling of hair and
    # gnashing of teeth and fraying of nerves.  Don't do it.
    #
    # Really.
    
    meta_type='Portal ExtFile'

    __ac_permissions__ = (
        ('View', ('download',)),
        ('Change Portal Files', ('edit',), ('Owner',)),
        ('View management screens',('editForm',)),
        )
    
    def SearchableText(self):
        """
        SeachableText is used for full text seraches of a portal.  It
        should return a concatanation of all useful text.
        """
        return "%s %s" % (self.title, self.descr)

    def toolbox_actions(self, url=0):
        if url==0: url=self.absolute_url()
        return (
            {'name':'View statistics',
             'url':  url + '/index_html',
             'permissions':('View',),
             'category':'object',
             },  
            {'name':'Download',
             'url':  url + '/download',
             'permissions':('View',),
             'category':'object',
             },  
            {'name':'Edit',
             'url':  self.absolute_url() + '/editForm',
             'permissions':('Change Portal Files',),
             'category':'object',
             },
            )


    def manage_afterAdd(self, item, container):
        """Both of my parents have an afterAdd method"""
        Products.ExtFile.ExtFile.ExtFile.manage_afterAdd(self, item, container)
        PortalContent.manage_afterAdd(self, item, container)

    def manage_beforeDelete(self, item, container):
        """Both of my parents have a beforeDelete method"""
        PortalContent.manage_beforeDelete(self, item, container)
        Products.ExtFile.ExtFile.ExtFile.manage_beforeDelete(self, item, container)
        

    def edit(self, title, description, content_type,
             precondition='', file='', REQUEST=None):
        """
        Perform changes for user
        """
        self.title = title
        self.descr = self.description = description
        self.content_type = content_type

        if file:
            self.manage_file_upload(file)

        # Tell the portal I changed
        self.getPortal().notify_content(
            self, self.getPortal().getAuthenticatedMember())
        
        if REQUEST is not None:
            return self.editForm(self, REQUEST,
                                 portal_status_message='File changed.')

    def download(self, REQUEST, RESPONSE):
        """
        Download this item.  Calls OFS.Image.File.index_html to perform the
        actual transfer after first setting Content-Disposition to suggest
        a filename.
        """

        RESPONSE.setHeader('Content-Disposition',
                           'attachment; filename="%s"' % self.id())
        return Products.ExtFile.ExtFile.ExtFile.index_html(self, REQUEST, RESPONSE)

    editForm = HTMLFile('dtml/fileEdit', globals())
    index_html = HTMLFile('dtml/fileView', globals())


Globals.default__class_init__( ExtFile )

# PortalContent classes need to be registered.  This installs the
# class's factory method and icon.

from Products.PTKBase.register import registerPortalContent

registerPortalContent( ExtFile
                     , constructors=( addExtFile, )
                     , action='Wizards/ExtFile'
                     , icon=Globals.ImageFile( "extFile.gif", globals() )
                     )
